# __gnu_debug::_Safe_association< _Base > Class Template Reference

Inheritance diagram for __gnu_debug::_Safe_association< _Base >:

List of all members.

## Detailed Description

### template<typename _Base>
class __gnu_debug::_Safe_association< _Base >

Base class for constructing a "safe" associated container type.

The class template _Safe_association simplifies the construction of "safe" associated containers.

Definition at line 52 of file safe_association.h.

## Public Types

- typedef _Base::allocator_type allocator_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::const_iterator,
  _Safe_association > const_iterator
- typedef _Base::const_reference const_reference
- typedef _Base::difference_type difference_type
- typedef _Base::hasher hasher
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::iterator,
  _Safe_association > iterator
- typedef _Base::key_equal key_equal
- typedef _Base::key_type key_type
- typedef _Base::reference reference
- typedef _Base::size_type size_type
- typedef _Base::value_type value_type

## Public Member Functions

- const _Base & _M_base () const
- _Base & _M_base ()
- _Safe_association (_Safe_association &&__x)
- _Safe_association (const _Base &__x)
- template<typename _InputIter> _Safe_association (_InputIter __f, _InputIter __l, size_type __n, const hasher &__hf, const key_equal &__eql, const allocator_type &__a=allocator_type())
- template<typename _InputIter> _Safe_association (_InputIter __f, _InputIter __l, size_type __n, const hasher &__hf)
- template<typename _InputIter> _Safe_association (_InputIter __f, _InputIter __l, size_type __n)
- template<typename _InputIter> _Safe_association (_InputIter __f, _InputIter __l)
- _Safe_association (size_type __n, const hasher &__hf, const key_equal &__eql, const allocator_type &__a=allocator_type())
- _Safe_association (size_type __n, const hasher &__hf)
- _Safe_association (size_type __n)
- _Safe_association ()
- const_iterator begin () const
- const_iterator end () const
- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__key) const
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __it)
- size_type erase (const key_type &__key)
- const_iterator find (const key_type &__key) const
- template<typename _InputIter> void insert (_InputIter __first, _InputIter __last)
- void insert (const value_type *__first, const value_type *__last)
- std::pair< iterator, bool > insert (const value_type &__obj)

The documentation for this class was generated from the following file:

- safe_association.h